version 16
<br>
<?php
require_once("/home/data/httpd/eclipse-php-classes/system/dbconnection_projectinfo_ro.class.php");

class ProjectInfoData
{
private $rows; // raw query results for database, ProjectID, MainKey, SubKey, Value, ProjectInfoID
private $mainkeys; // [main key] -> # of rows
private $subkeys;  // [main key] -> true if has subkeys, false otherwise

function ProjectInfoData( $projectid )
{
	$dbc = new DBConnectionProjectInfo();
	$dbh = $dbc->connect();
	$result = mysql_query("
				SELECT * FROM ProjectInfo, ProjectInfoValues 
					WHERE ProjectID = '$projectid' 
					  AND ProjectInfo.ProjectInfoID = ProjectInfoValues.ProjectInfoID", $dbh);
	$this->rows = array();
	$this->mainkeys = array();
	$this->subkeys = array();
	while($row = mysql_fetch_assoc($result)) {
		$this->rows[] = $row;
		$mainkey = $row['MainKey'];
		if( isset($this->mainkeys[$mainkey])) 
			$this->mainkeys[$mainkey]++;
		else
			$this->mainkeys[$mainkey] = 1;
		if( !isset($this->subkeys[$mainkey]))
			$this->subkeys[$mainkey] = false;
		if( $row['SubKey'] != null )
			$this->subkeys[$mainkey] = true;
	}
}

function __get( $varname )
{
	foreach( $this->rows as $row ) {
		$mainkey = $row['MainKey'];
		if( $mainkey == $varname ) {
			if( $this->mainkeys[$mainkey] == 1 ) {
				if( $this->subkeys[$mainkey] == false ) {
					return $row['Value'];
				} else {
					$subrows = array();
					foreach( $this->rows as $rr ) {
						if( $row['ProjectInfoID'] == $rr['ProjectInfoID']) {
							$subrows[] = $rr;
						}
					}
					return new ProjectInfoValues( $this, $subrows );
				}
			} else {
				if( $this->subkeys[$mainkey] == false ) {
					$result = array();
					foreach( $this->rows as $rr ) {
						if( $rr['MainKey'] == $mainkey) {
							$result[] = $rr['Value'];
						}
					}
					return $result;
				} else {
					$result = array();
					foreach( $this->rows as $rr ) {
						if( $rr['MainKey'] == $mainkey) {
							$subrows = array();
							foreach( $this->rows as $rr ) {
								if( $row['ProjectInfoID'] == $rr['ProjectInfoID']) {
									$subrows[] = $rr;
								}
							}
							$result[] = new ProjectInfoValues( $this, $subrows );
						}
					}
					return $result;
				}
			}
		}
	}
	return null;
}
}
class ProjectInfoValues {
private $rows;
function ProjectInfoValues( $projectinfo, $subrows ) {
	$this->rows = $subrows;
}
function __get( $varname )
{
	foreach( $this->rows as $row ) {
		$subkey = $row['SubKey'];
		if( $subkey == $varname ) {
			return $row['Value'];
		}
	}
	return null;
}
}

$info = new ProjectInfoData( 'technology.dash');

?><hr>
$info = new ProjectInfoData( 'technology.dash');<br>
$info->pargraphurl = '<?= $info->paragraphurl ?>'<br>
$info->descriptionurl = '<?= $info->descriptionurl ?>'<br>
$info->bugzilla->productname = '<?= $info->bugzilla->productname ?>'<br>
$info->mailinglist[0]->name = '<?= $info->mailinglist[0]->name ?>'<br>
$info->mailinglist[0]->description = '<?= $info->mailinglist[0]->description ?>'<br>

